#
# spec file for package cinelerra-cv
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) Leon Freitag (leon@links2linux.de).
# Copyright (c) 2013 Mariusz Fik <fisiu@opensuse.org>.
# Copyright (c) 2014 Packman team: http://packman.links2linux.org/
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.links2linux.org/
#


%define git_date git.20150706
%define src_name CinelerraCV
%define soname 1
%define soquicktime 1_6_0-%{soname}
%define sompeg3 1_5_0-%{soname}
Name:           cinelerra-cv
Version:        2.3.0
Release:        2.4
Summary:        A non linear video editor and effects processor
License:        GPL-2.0
Group:          Productivity/Multimedia/Video/Editors and Convertors
Url:            http://cinelerra-cv.org/
Source0:        http://cinelerra-cv.org/releases/%{src_name}-2.3.tar.xz
Patch1:         cinelerracv-2.2-no-buildtime.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  docbook2x
BuildRequires:  nasm
BuildRequires:  libfaac-devel >= 1.24
BuildRequires:  libfaad-devel
BuildRequires:  libjpeg8-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libffmpeg_oldabi-devel
BuildRequires:  opencv-devel
BuildRequires:  pkgconfig(OpenEXR) >= 1.1.1
BuildRequires:  pkgconfig(alsa) >= 1.0.4
BuildRequires:  pkgconfig(audiofile) >= 0.2.3
BuildRequires:  pkgconfig(esound) >= 0.2.28
BuildRequires:  pkgconfig(fftw3)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(freetype2) >= 2.2.1
BuildRequires:  pkgconfig(glu)
BuildRequires:  pkgconfig(liba52) >= 0.7.4
BuildRequires:  pkgconfig(libavc1394) >= 0.4.1
BuildRequires:  pkgconfig(libdv) >= 1.0.0
BuildRequires:  pkgconfig(libiec61883) >= 1.0.0
BuildRequires:  pkgconfig(libraw1394) >= 1.2.0
BuildRequires:  pkgconfig(libtiff-4) >= 3.6.0
BuildRequires:  pkgconfig(mjpegtools) >= 1.6.2
BuildRequires:  pkgconfig(ogg) >= 1.1.2
BuildRequires:  pkgconfig(libpng) >= 1.2.5
BuildRequires:  pkgconfig(sndfile)
BuildRequires:  pkgconfig(theora)
BuildRequires:  pkgconfig(uuid)
BuildRequires:  pkgconfig(vorbis) >= 1.0.0
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(x264)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xft)
BuildRequires:  pkgconfig(xv)
BuildRequires:  pkgconfig(xxf86vm)
BuildRequires:  update-desktop-files
BuildRequires:  hicolor-icon-theme
#disable the code checks, I'm not going to mess with the Cinelerra code, although the warnings seem strange.

Requires:       mjpegtools
Provides:       cinelerra = %{version}
Obsoletes:      cinelerra < %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Non-linear audio/video authoring tool Cinelerra-CV is a complete audio and
video authoring tool. It understands a lot of multimedia formats
(quicktime, avi, ogg) and audio/video compression codecs (divx, xvid,
mpeg1/2, ...). This is the community-maintained version of Cinelerra.

%package -n     libguicast%{soname}
Summary:        Toolkit library (cinelerra's internal)
Group:          System/Libraries
Provides:       libguicastcv%{soname} = %{version}

%description -n libguicast%{soname}
Is a toolkit library mainly used by HeroineVirtual's software.

%package -n     libmpeg3hv-%{sompeg3}
Summary:        Advanced editing and manipulation of MPEG streams
Group:          System/Libraries
Provides:       libmpeg3cv-%{sompeg3} = %{version}

%description -n libmpeg3hv-%{sompeg3}
Libmpeg3 supports advanced editing and manipulation of MPEG streams. MPEG
is normally a last mile format but with libmpeg3 you can edit it like a
first mile solution.

%package -n     libquicktimehv-%{soquicktime}
Summary:        Quicktime 4 Linux Cinelerra internal library
Group:          System/Libraries
Provides:       libquicktimecv-%{soquicktime} = %{version}

%description -n libquicktimehv-%{soquicktime}
Quicktime 4 Linux was the first convenient way to read and write
uncompressed Quicktime movies on Linux. Today Quicktime 4 Linux is intended
for content creation and uncompressed movies. These usually arise during
the production phase and not the consumer phase of a movie. It has
improvements in colormodel support, bit depth, accuracy, reliability, and
codecs, while not stressing economy.

%package -n     libguicast-devel
Summary:        Development files for %{name}
Group:          Development/Libraries/Other
Requires:       libguicastcv%{soname} = %{version}

%description -n libguicast-devel
Toolkit library (cinelerra's internal).

This packages provides files needed for compiling stuff.

%package -n     libmpeg3hv-devel
Summary:        Development files for %{name}
Group:          Development/Libraries/Other
Conflicts:      libmpeg3-devel
Requires:       libmpeg3cv-%{sompeg3} = %{version}

%description -n libmpeg3hv-devel
Advanced editing and manipulation of MPEG streams.

This packages provides files needed for compiling stuff.

%package -n     libquicktimehv-devel
Summary:        Development files for %{name}
Group:          Development/Libraries/Other
Conflicts:      pkgconfig(libquicktime)
Requires:       libquicktimecv-%{soquicktime} = %{version}

%description -n libquicktimehv-devel
Quicktime 4 Linux Cinelerra internal library.

This packages provides files needed for compiling stuff.

%lang_package

%prep
%setup -q -n %{src_name}-2.3
%patch1 -p1

%build
./autogen.sh
export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="$CFLAGS -O3 -pipe -D__STDC_CONSTANT_MACROS"
%configure \
    --with-plugindir=%{_libdir}/%{name} \
    --with-buildinfo=cust/Packman\ build \
    --with-external-ffmpeg \
    --enable-opengl

make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install
# rename the mpeg3 utils so they can be installed alongside SuSE native versions
pushd %{buildroot}/%{_bindir}
mv mpeg3toc{,cv}
mv mpeg3cat{,cv}
mv mpeg3dump{,cv}
mv cinelerra %{name}
popd

find %{buildroot} -type f -name "*.la" -delete -print

%suse_update_desktop_file -c %{name} Cinelerra-CV "Video Editor" %{name} %{name} Multimedia AudioVideoEditing

%find_lang %{name}

%post -n libguicast%{soname} -p /sbin/ldconfig
%postun -n libguicast%{soname} -p /sbin/ldconfig

%post -n libmpeg3hv-%{sompeg3} -p /sbin/ldconfig
%postun -n libmpeg3hv-%{sompeg3} -p /sbin/ldconfig

%post -n libquicktimehv-%{soquicktime} -p /sbin/ldconfig
%postun -n libquicktimehv-%{soquicktime} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING TODO ChangeLog
%{_bindir}/%{name}
%{_bindir}/mplexlo
%{_bindir}/mpeg3dumpcv
%{_bindir}/mpeg3toccv
%{_bindir}/mpeg3catcv
%{_libdir}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.xpm

%files -n libguicast%{soname}
%defattr(-,root,root)
%{_libdir}/libguicast.so.*

%files -n libmpeg3hv-%{sompeg3}
%defattr(-,root,root)
%{_libdir}/libmpeg3hv*.so.*

%files -n libquicktimehv-%{soquicktime}
%defattr(-,root,root)
%{_libdir}/libquicktimehv*.so.*

%files -n libguicast-devel
%defattr(-,root,root)
%{_libdir}/libguicast.so

%files -n libmpeg3hv-devel
%defattr(-,root,root)
%dir %{_includedir}/mpeg3
%{_includedir}/mpeg3/libmpeg3.h
%{_includedir}/mpeg3/mpeg3private.h
%{_libdir}/libmpeg3hv.so

%files -n libquicktimehv-devel
%defattr(-,root,root)
%dir %{_includedir}/quicktime
%{_includedir}/quicktime/qtprivate.h
%{_includedir}/quicktime/quicktime.h
%{_libdir}/libquicktimehv.so

%files lang -f %{name}.lang
%defattr(-,root,root)

%changelog
* Tue Dec  8 2015 avvissu@yandex.ru
- Use opencv-devel instead of pkgconfig(opencv)
* Tue Sep  8 2015 avvissu@yandex.ru
- Update to 2.3.0:
  * full UTF-8 support
  * complete new overlay engine and resampler
  * new graphics: About panel, some icons
  * new plugins: GreyCStoration, C41, Bluebanana, color3way,
    findobject, lens
  * some translations have been updated (German, Italian, French,
    Norwegian, Portugese)
  * lots of small bugfixes
- Use stable release instead of git:
  * cnahge _service: add parameter "revision"
* Sat Jul 25 2015 avvissu@yandex.ru
- Update to git20150706
- Rename package: cinelerra -> cinellera-cv
- Update patches:
  * cinelerra-no-buildtime -> cinelerracv-2.2-no-buildtime.patch
- Use pkgconfig(foo) style
- Add a new app description
- Add new packages: libguicast, libmpeg3hv, libquicktimehv
- Add explicit Conflicts: libmpeg3-devel, pkgconfig(libquicktime)
- Create a new desktop file: cinelerra-cv
- Spec file cleanup
* Sun Feb 16 2014 dap.darkness@gmail.com
- Update to latest git snapshot (20130909).
- Clean section was deleted.
- Rpm opt flags became used.
* Wed Mar 20 2013 fisiu@opensuse.org
- Update to latest git snapshot (20120923).
- Spec cleanup.
* Sat May 19 2012 seife+obs@b1-systems.com
- fix build on 12.2 by adding autoconf & co buildrequires
* Sat Nov 26 2011 leon@links2linux.de
- new release CV 2.2
* Tue Feb 22 2011 leon@links2linux.de
- new release CV 2.1.5
* Sun Aug  1 2010 leon@links2linux.de
- use latest version from Simen Voelkl's repository (cin2.1sv)
- enabled opengl
- Suse 11.3 build
* Mon Jun 29 2009 leon@links2linux.de
- updated the git version to the latest one with the dnxhd codec
- converted the russian translation to UTF8
* Tue Jan  6 2009 leon@links2linux.de
- new versioning scheme, as cinelerra moved to git and dropped the release numbers
- Suse 11.1 build
* Thu Jul  3 2008 leon@links2linux.de
- added a patch to compile on gcc 4.3/Suse 11.0, thanks to Toni and Rain_Maker
* Sat Oct  6 2007 leon@links2linux.de
- svn r1036
* Wed Mar 28 2007 leon@links2linux.de
- svn r1006
- added the custom buildinfo
* Mon Nov 13 2006 leon@links2linux.de
- svn r958
- updated for the new x264 version
* Tue Sep 26 2006 leon@links2linux.de
- changed the spec to match the packman/SP conventions
- svn r909
* Thu Sep 14 2006 cobra@compuserve.com
- First package with merged Cinelerra 2.1
- svn r888
* Thu Jun  1 2006 cobra@compuserve.com
- transitions fix, Ogg renderfarm support, po email address fix
- file.h compile fix, fix thread delete race condition
- a bunch of mem management fixes
* Mon May 29 2006 cobra@compuserve.com
- reading ogg vorbis fix, Freetype2 2.2.1 compatibility
- mjpeg load fixes (bug139, 148, 259), fix insertion of media files directly
- shorten xml files, motion blur plugin
- camera and projector automation for plugins, waveform not shown fix
- change every clip all media files behavior in saved xml
- work without audio enabled, delete pluginsets fix
* Tue May  2 2006 cobra@compuserve.com
- fseek0 fix bug244, bug250, check sound/audio in dv format
- bug249 vorbis setup fix, chromakey fix, check for libfaac
- fix DV audio read sample impl., move icon in Gnome
- bug30 allow transition at end of track, bug243
- fix crash when rendering plugins, fix null plugin usage
- fix load XML crash, bug242 >1024 properties
* Mon Apr  3 2006 cobra@compuserve.com
- EDL export, .mov DV fourcc -> dvc, multi transitions with diff lengths fix
- debian build fixes, new configure checks and libavcodec header fixes
- mux fixes for long silence/empty video, ubuntu build fixes
- RGB*_FLOAT color models for mask engine, gcc 4.1.0 fixes/mpeg2enc
- Makefile cleanups, raise_window() commands, BUZ driver channel editor fixes
- format selection for timecode in titler, build date and CV versioning
- fix --disable-firewire, chromakey-hsv plugin, pt_BR translation updates
- deinterlace plugin updates, cache frames even when not static
- new deinterlacer, timefronts - take from alpha
- fix apply-mask-before-plugins for masks, new timefront plugin
- add histogram split checkbox
* Sat Feb  4 2006 cobra@compuserve.com
- vertical pos of auto-zoom text, dv audio offset/framing fix
- Italian translation, Spanish update, deinterlace fix
- mpeg encode params fix
* Thu Jan 26 2006 cobra@compuserve.com
- raw dv i/o fixes, textual info for labels, " conversion
- Automation text label editable, audio_position adjust for dv1394
* Sat Dec 24 2005 cobra@compuserve.com
- fix bug 219 & 220, make text menu hilight white
- alt+left/right navigates trough edit handles
- parameter name fix, single image dnd fixes, remove mwindowmove dup code
- ffmpeg defaults for elem stream (Bug 164), member function fix
- gettextize language changes for more plugins, French update
* Sun Dec 11 2005 cobra@compuserve.com
- Fix renderfarm client crash, align cursor on frames default
- right mouse on keyframe - keyframe popup, guicast / gettextize additions
- Brazilian update, French update
- link mpeg2enc.plugin for SUSE, add mjpegtools >= 1.6.3 dep
* Mon Nov 14 2005 cobra@compuserve.com
- Initial build of CV from svn tree.
